
local ALPHA = "ALPHA"
local UNKNOWN = "UNKNOWN"
local releaseString = nil
LootCouncil = LibStub("AceAddon-3.0"):NewAddon("LootCouncil", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceTimer-3.0")
local addon = LootCouncil
local L = LibStub("AceLocale-3.0"):GetLocale("LootCouncil")
local df = LibStub("LibDeformat-3.0")
local db, dbpc
local pname = UnitName("player")
local windowString = ""
local timer, timercount

do -- Borrowed from BigWigs :)
	-- START: MAGIC WOWACE VOODOO VERSION STUFF
	local releaseType = RELEASE
	local releaseRevision = nil
	
	--@alpha@
	-- The following code will only be present in alpha ZIPs.
	releaseType = ALPHA
	--@end-alpha@

	-- This will (in ZIPs), be replaced by the highest revision number in the source tree.
	releaseRevision = tonumber("2")

	-- If the releaseRevision ends up NOT being a number, it means we're running a SVN copy.
	if type(releaseRevision) ~= "number" then
		releaseRevision = -1
	end

	-- Then build the release string, which we can add to the interface option panel.
	local majorVersion = GetAddOnMetadata("LootCouncil", "Version") or "0.?"
	if releaseRevision == -1 then
		releaseString = L["You are running a source checkout of LootCouncil %s directly from the repository."]:format(majorVersion) -- Version message, %s = majorVersion
		windowString = "(Development)"
	elseif releaseType == RELEASE then
		windowString = "(" .. majorVersion .. "Release)"
	elseif releaseType == ALPHA then
		releaseString = L["You are running an ALPHA RELEASE of LootCouncil %s (revision %d). Please report any bugs @ http://www.wowace.com/addons/LootCouncil/tickets/"]:format(majorVersion, releaseRevision) -- Version message, %s = majorVersion, %d = revision
		windowString = "(" .. majorVersion .. "r" .. releaseRevision .. " ALPHA)"
	end
	_G.LOOTCOUNCIL_RELEASE_TYPE = releaseType
	_G.LOOTCOUNCIL_RELEASE_REVISION = releaseRevision
	_G.LOOTCOUNCIL_RELEASE_STRING = releaseString
	-- END:   MAGIC WOWACE VOODOO VERSION STUFF
end
addon.loots = {}

--[[LCTestItems = {
	["Lyrotha"] = "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r offspec",
	["Mopery"] = "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r",
	["Cereis"] = "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r",
	["Egonor"] = "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r os",
	["Whiteycm"] = "|cffa335ee|Hitem:50759:0:0:0:0:0:0:0:0|h[Bone Warden's Splitter]|h|r",
	["Janosszabo"] = "|cffa335ee|Hitem:50772:0:0:0:0:0:0:0:0|h[Ancient Skeletal Boots]|h|r"
}]]

local ignoredItems = {
	[30316] = true, -- Devastation
	[30317] = true, -- Cosmic Infuser
	[30312] = true, -- Infinity Blade
	[30318] = true, -- Netherstrand Longbow
	[30313] = true, -- Staff of Disintegration
	[30311] = true, -- Warp Slicer
	[30320] = true, -- Bundle of Nether Spikes
	[30314] = true, -- Phaseshift Bulwark
	[30319] = true, -- Nether Spikes
	[29434] = true, -- Badge of Justice
	[40752] = true, -- Emblem of Heroism
	[40753] = true, -- Emblem of Valor
	[45624] = true, -- Emblem of Conquest
	[47241] = true, -- Emblem of Triumph
	[49426] = true, -- Emblem of Frost
	[22450] = true, -- Void Crystal
	[20725] = true, -- Nexus Crystal
	[34057] = true, -- Abyss Crystal
}

function addon:OnInitialize()
	addon:SetEnabledState(false)
	--- Setup Databases, Options
	addon.firstload = true
	addon.councillors = {}
	--[[self:AddCouncillor("Lyrotha")
	self:AddCouncillor("Whiteycm")
	self:AddCouncillor("Janosszabo")
	self:AddCouncillor("Cereis")
	self:AddCouncillor("Egonor")
	self:AddCouncillor("Mopery")
	self:AddLoot(50764)
	self:AddLoot(50763)
	self:AddLoot(50762)
	self:AddLoot(50771)
	self:AddMessage(50764, "Lyrotha", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r offspec")
	self:AddMessage(50764, "Mopery", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r")
	self:AddMessage(50764, "Cereis", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r")
	self:AddMessage(50764, "Egonor", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r os")
	self:AddMessage(50764, "Egonor", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r os")
	self:AddMessage(50764, "Egonor", "|cffa335ee|Hitem:50774:0:0:0:0:0:0:0:0|h[Coldwraith Bracers]|h|r os")
	self:AddMessage(50764, "Whiteycm", "|cffa335ee|Hitem:50759:0:0:0:0:0:0:0:0|h[Bone Warden's Splitter]|h|r")
	self:AddMessage(50764, "Janosszabo", "|cffa335ee|Hitem:50772:0:0:0:0:0:0:0:0|h[Ancient Skeletal Boots]|h|r")]]
    self.db = LibStub("AceDB-3.0"):New("LootCouncilDB", {
			profile = {
				debug = false,
				autotrack = false,
				allatonce = false,
				autoclosetime = 30,
				autovoteclosetime = 30,
				raritythreshold = 0,
				optionmaster = pname,
				channels = {"Raid"},
				ranks = {}
			},
		})
	db = self.db.profile
	local LDB = LibStub("LibDataBroker-1.1", true)
	launcher = LDB:NewDataObject("LootCouncil", {
		type = "data source",
		label = "LootCouncil",
		text = addon:IsEnabled() and "|cff00FF00Enabled|r" or "|cffFF0000Standby|r",
		icon = addon:IsEnabled() and "Interface\\ICONS\\INV_Misc_GroupNeedMore" or "Interface\\ICONS\\INV_Misc_GroupLooking",
		OnClick = function(clickedframe, button)
			if button == "RightButton" then 
				addon:ToggleWindow()
			else 
				if IsControlKeyDown() then 
					addon:ShowConfig() 
				else 
					if addon:IsEnabled() then
						addon:Disable()
					else
						addon:Enable()
					end
				end 
			end
		end,
		OnTooltipShow = function(tt) 
			tt:AddLine(L["LootCouncil"]) -- LDB Tooltip title

			
			tt:AddLine(L["|cff00FF00Click to enable/disable|r"]) -- LDB click help: toggle
			--tt:AddLine(L["|cff00FF00Shift-click to take ontime attendance time|r"]) -- LDB right-click help: options
			tt:AddLine(L["|cff00FF00Ctrl-click to open options|r"]) -- LDB right-click help: options
			tt:AddLine(L["|cff00FF00Right-click to open the loot council window|r"]) -- LDB right-click help: options
		end,
	})
	
	-- get timezone for time(), useful for uploads into GMT/UTC
	local function get_timezone()
		local now = time()
		return difftime(now, time(date("!*t", now)))
	end
	-- Return a timezone string in ISO 8601:2000 standard form (+hhmm or -hhmm)
	local function get_tzoffset(timezone)
		local h, m = math.modf(timezone / 3600)
		return string.format("%+.4d", 100 * h + 60 * m)
	end
	db.timezone = tonumber(get_tzoffset(get_timezone()))
	addon:RegisterComm("LootCouncil")
	addon:CommHandlers()
	addon:RegisterEvent("RAID_ROSTER_UPDATE")
	addon:RegisterEvent("LOOT_OPENED")
	addon:RegisterEvent("CHAT_MSG_LOOT")
	--addon:Disable()
	LibStub("AceConsole-3.0"):RegisterChatCommand( "everyquest", function() addon:ToggleWindow() end)
end

function addon:OnEnable()
	--
	--
	--addon:RegisterEvent("CHAT_MSG_RAID")
	--addon:RegisterEvent("GUILD_ROSTER_UPDATE")
	
	
	
	launcher.text = "|cff00FF00Enabled|r"
	launcher.icon = "Interface\\ICONS\\INV_Misc_GroupNeedMore" -- Tracking icon
	
	--[[if IsInGuild() then 
		wipe(db.guildinfo.ranks)
		for i = 1, GuildControlGetNumRanks() do
			db.guildinfo.ranks[i] = GuildControlGetRankName(i)
		end
		db.guildinfo.name = GetGuildInfo("player")
		db.guildinfo.server = GetRealmName()
	end]]
	
	--[[if self.firstload then
		self:Print(releaseString)
		self.firstload = false
	end]]
end

function addon:OnDisable()
	--addon:UnregisterEvent("RAID_ROSTER_UPDATE")
	--addon:UnregisterEvent("CHAT_MSG_LOOT")
	--addon:UnregisterEvent("CHAT_MSG_RAID")
	--addon:UnregisterEvent("GUILD_ROSTER_UPDATE")
	addon:UnregisterEvent("LOOT_OPENED")
	--addon:UnRegisterComm("LootCouncil")
	launcher.text = "|cffFF0000Standby|r"
	launcher.icon = "Interface\\ICONS\\INV_Misc_GroupLooking" -- Not tracking icon
end

function addon:CommHandlers()
	addon.commhandlers = {
		active = function(message, distribution, sender)
			if not addon:IsEnabled() then
				addon:Enable()
				addon:Introduce()
			end
		end,
		hello = function(message, distribution, sender)
			if not addon:IsEnabled() then
				addon:Enable()
			end
			addon:SendComm("hi")
			addon:AddCouncillor(pname)
			addon:AddCouncillor(sender)
		end,
		hi = function(message, distribution, sender)
			addon:AddCouncillor(sender)
		end,
		ack = function(message, distribution, sender)
			-- itemID, player, message, num
			local itemID, player, message, num = message:match("^(.+)%%(.+)||(.+)%%(.+)$")
		end,
		al = function(message, distribution, sender)
			-- itemID
			local itemID, quantity = message:match("^(.+)%%(.+)$")
			addon:AddLoot(itemID, tonumber(quantity), sender)
		end,
		start = function(message, distribution, sender)
			-- itemID
			local itemID = tonumber(message)
			addon:StartLoot(itemID, sender)
		end,
		vote = function(message, distribution, sender)
			-- player, messagenum, itemID, value
			local player, messagenum, itemID, value = message:match("^(.+)%%(.+)%%(.+)%%(.+)$")
			addon:Vote(player, tonumber(messagenum), tonumber(itemID), tonumber(value), sender)
		end,
		finishvote = function(message, distribution, sender)
			-- itemID
			local itemID = tonumber(message)
			addon:FinishVote(tonumber(itemID), sender)
		end,
		option = function(message, distribution, sender)
		
		end,
	}
end

function addon:SendComm(type, ...)
	--print(type, select("#", ...), ...)
	--if UnitInRaid("player") ~= nil then
		local message = type .. " "
		for i = 1, select("#", ...) do
			message = message .. tostring(select(i, ...))
			if i < select("#", ...) then
				message = message .. "%%"
			end
		end
		-- if select("#", ...) > 1 then
			-- message = type .. " " .. table.concat(arg, "||")
		-- else
			-- message = type .. " " .. ...
		-- end
		self:SendCommMessage("LootCouncil", message, "RAID")
	--end
end

function addon:OnCommReceived(prefix, message, type, sender)
	--if prefix == "LootCouncil" then
		print(prefix, message, type, sender)
	--end
	if prefix ~= "LootCouncil" or sender == pname then return end
	
	local sync, rest = select(3, message:find("(%S+)%s*(.*)$"))
	--local commtype, remainder = message:match("^(%a)(.*)")
	if (not sync) or (not addon.commhandlers[sync]) then return end
	
	addon.commhandlers[sync](rest, distribution, sender)
end

function addon:GetItemIdFromLink(link)
	return tonumber(string.match(link, 'item:(%d+)'))
end

function addon:LOOT_OPENED()
	numLootItems = GetNumLootItems()
	local itemIDs = {}
	
	for i = 1, numLootItems do
		local itemLink = GetLootSlotLink(i)
		local _, _, lootQuantity, rarity, locked = GetLootSlotInfo(i)
		if rarity >= db.raritythreshold and not locked and lootQuantity > 0 then
			if itemIDs[itemLink] == nil then
				itemIDs[itemLink] = lootQuantity
			else
				itemIDs[itemLink] = itemIDs[itemLink] + lootQuantity
			end
		end
	end
	if select("#", itemIDs) > 0 then
		if not addon:IsEnabled() then
			addon:Enable()
			addon:Introduce()
		end
		self:SendComm("active")
	end
	for k,v in pairs(itemIDs) do
		addon:AddLoot(k, v)
	end
end

function addon:GetTabs(getfirst)
	local tabs = {}
	if select("#", addon.loots) > 0 then
		for k,v in pairs(addon.loots) do
			if not v.disabled then
				if getfirst then
					return k
				else
					table.insert(tabs, {text=GetItemInfo(k), value=k})
				end
			end
		end
		return tabs
	else
		return false
	end
end

function addon:Introduce()
	addon:AddCouncillor(pname)
	self:SendComm("hello")
end

function addon:AddMessage(itemID, player, message)
	if not addon.loots[itemID].players then
		addon.loots[itemID].players = {}
	end
	if not addon.loots[itemID].players[player] then
		addon.loots[itemID].players[player] = {}
	end
	local num = #addon.loots[itemID].players[player] + 1
	addon.loots[itemID].players[player][num] = {votes = {}, message = message}
	self:SendComm("ack", itemID, player, num, message)
end

function addon:AddLoot(itemLink, quantity, from)
	local itemID = self:GetItemIdFromLink(itemLink)
	if addon.loots[itemID] == nil then
		addon.loots[itemID] = {}
	end
	addon.loots[itemID]["disabled"] = false
	addon.loots[itemID]["stage"] = 0
	addon.loots[itemID]["looted"] = {}
	addon.loots[itemID]["added"] = time()
	addon.loots[itemID]["quantity"] = quantity or 1
	addon.loots[itemID]["votedone"] = {}
	if addon.window then
		addon.window.tabs:SetTabs(addon:GetTabs())
		addon.window.tabs:SelectTab(addon:GetTabs(true))
	end
	if not from then
		addon:SendComm("al", itemLink, quantity)
	end
	return true
end

function addon:ParseChat(event, message, sender, ...)
	--|cffa335ee|Hitem:47976:3721:3526:3526:0:0:0:849462768:80|h[Legplates of the Immortal Spider]|h|r
	local pattern = "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?" -- Itemlink pattern
	pattern = "|?c?f?f?%x*|?H?[^:]*:?%d+:?%d*:?%d*:?%d*:?%d*:?%d*:?%-?%d*:?%-?%d*:?%d*|?h?%[?[^%[%]]*%]?|?h?|?r?" -- Itemlink pattern
	local items = {}
	for _,item in string.gmatch(message, pattern) do
      table.insert(items, item)
    end
	if Spew then
		Spew("items", items)
	end
end

function addon:AddCouncillor(name)
	for _,v in pairs(self.councillors) do
		if name == v then
			return false
		end
	end
	table.insert(self.councillors, name)
	table.sort(self.councillors, function(a, b)
		if a == pname then
			return true
		elseif b == pname then
			return false
		else
			return a < b
		end
	end)
	if addon.window then
		local str = table.concat(self.councillors, ", ")
		addon.window.councillors:SetText(L["Councillors: %s"]:format(str ~= "" and str or L["None"]) )
	end
end

function addon:GetCouncillors()
	return self.councillors
end

function addon:UpdateVoteCloseTime(itemID)
	timercount = timercount + 1
	if timercount < db.autovoteclosetime -1 then
		if itemID == addon.currenttab then
			addon.window.item:SetText(select(2, GetItemInfo(itemID)) .. L[", Voting closing in %d seconds"]:format(db.autovoteclosetime - timercount))
		end
	else
		addon.voting = nil
		if timer then
			self:CancelTimer(timer, true)
		end
		addon:FinishVote(itemID)
		self:RedrawTab(redraw)
	end
end

function addon:UpdateLootTime(itemID)
	timercount = timercount + 1
	if timercount < db.autoclosetime -1 then
		local timeleft = db.autoclosetime - timercount
		if itemID == addon.currenttab then
			addon.window.item:SetText(select(2, GetItemInfo(itemID)) .. L[", Closing in %d seconds"]:format(timeleft))
		end
		if timeleft <=5 and pname == addon.starter then
			self:Print(L["Closing in %s"]:format(timeleft))
		end
	else
		if timer then
			self:CancelTimer(timer, true)
		end
		self:StartLoot(nil)
	end
end

function addon:StartLoot(itemID, from)
	if not from then 
		if itemID then
			self:Print(L["%s is now open for Loot Council, Closing in %s seconds. Link upgrades now to %s"]:format(select(2,GetItemInfo(itemID)), db.autoclosetime, table.concat(db.channels, L[" or "])))
		else
			self:Print(L["%s is now closed for Loot Council"]:format(select(2,GetItemInfo(addon.open))))
		end
		addon.starter = pname
		addon:SendComm("start", itemID)
	else
		addon.starter = from
	end
	local redraw
	if not itemID then
		if addon.open then
			addon:UnregisterEvent("CHAT_MSG_RAID", "ParseChat")
			addon:UnregisterEvent("CHAT_MSG_RAID_LEADER", "ParseChat")
			addon:UnregisterEvent("CHAT_MSG_PARTY", "ParseChat")
			redraw = addon.open
			if timer then
				self:CancelTimer(timer, true)
			end
			timercount = 0
			addon.voting = redraw
			if addon.voting == addon.currenttab then
				if not addon.window or not addon.window:IsShown() then
					addon:ToggleWindow()
					addon.window.tabs:SelectTab(addon.open)
				end
				addon.window.item:SetText(select(2, GetItemInfo(redraw)) .. L[", Voting closing in %d seconds"]:format(db.autovoteclosetime - timercount))
			end
			timer = self:ScheduleRepeatingTimer("UpdateVoteCloseTime", 1, redraw)
			addon.loots[redraw]["stage"] = 2
		end
	else
		addon:RegisterEvent("CHAT_MSG_RAID", "ParseChat")
		addon:RegisterEvent("CHAT_MSG_RAID_LEADER", "ParseChat")
		addon:RegisterEvent("CHAT_MSG_PARTY", "ParseChat")
		redraw = itemID
		timercount = 0
		if addon.open == addon.currenttab then
			if not addon.window or not addon.window:IsShown() then
				addon:ToggleWindow()
				addon.window.tabs:SelectTab(redraw)
			end
			addon.window.item:SetText(select(2, GetItemInfo(redraw)) .. L[", Closing in %d seconds"]:format(db.autoclosetime - timercount))
		end
		timer = self:ScheduleRepeatingTimer("UpdateLootTime", 1, redraw)
		addon.loots[itemID]["stage"] = 1
	end
	addon.open = itemID
	self:RedrawTab(redraw)
end

function addon:Vote(player, messagenum, itemID, value, from)
	if not from then
		addon.loots[itemID].players[player][messagenum].votes[pname] = value == false and nil or value
		addon:SendComm("vote", player, messagenum, itemID, value)
	else
		addon.loots[itemID].players[player][messagenum].votes[from] = value == false and nil or value
		self:RedrawTab(itemID)
	end
end

function addon:FinishVote(itemID, from)
	if not from then
		if not addon.loots[itemID].votedone[pname] then
			addon:SendComm("finishvote", itemID)
		end
		if addon.loots[itemID].stage == 1 or addon.loots[itemID].stage == 2 then
			addon.window.button2:SetDisabled(true)
		end
	end
	local name = from ~= nil and from or pname
	addon.loots[itemID].votedone[name] = true
	local numfinished = 0
	for _,councillor in pairs(addon.councillors) do
		if addon.loots[itemID].votedone[councillor] then
			numfinished = numfinished + 100
		end
	end	
	if numfinished == select("#", addon.councillors) and addon.voting ~= nil then
		if timer then
			self:CancelTimer(timer, true)
		end
		addon.voting = nil
	end
	self:RedrawTab(itemID)
end

function addon:TallyVotes(itemID)

end

function addon:RedrawTab(tab)
	if tab == self.currenttab then
		addon.window.tabs:SelectTab(tab)
	end
end

function addon:RAID_ROSTER_UPDATE()
	print("RAID_ROSTER_UPDATE")
	if UnitInRaid("player") then
		if not addon.initraid then
			addon:Introduce()
			addon.initraid = true
		end
		local method, partyID, raidID = GetLootMethod()
		if method == "master" then
		
		else
			
		end
	else
		addon.initraid = false
		wipe(addon.councillors)
	end
end

function addon:CHAT_MSG_LOOT(event, msg)
	local player, item = df:Deformat(msg, LOOT_ITEM)
	if not player then
		item = df:Deformat(msg, LOOT_ITEM_SELF)
		if item then
			player = UnitName("player")
		end
	end
	local quantity
	if item then
		quantity = tonumber(item:match("(%d-)$")) or 1
		itemID = tonumber(string.match(item, 'item:(%d+)'))
		if addon.loots[itemID] then
			if addon.loots[itemID].looted[player] then
				addon.loots[itemID].looted[player] = addon.loots[itemID].looted[player] + quantity
			else
				addon.loots[itemID].looted[player] = quantity
			end
			local count, amount = 0, addon.loots[itemID].quantity
			for k,v in pairs(addon.loots[itemID].looted) do
				count = count + v
			end
			if count >= amount then
				addon.loots[itemID].stage = 4
			end
			addon:RedrawTab(itemID)
			end
	end
	
	-- player, item, quantity
end

function addon:ToggleWindow()
	if not self.window then
		self:CreateWindow()
	end
	if self.window:IsShown() then
		self.window:Hide()
	else
		self.window:Show()
	end
end

do 
	--local guildMemberList = {}
	local coloredName
	--local updating = nil
	-- Helper table to cache hex colors for all classes.
	local hexColors = setmetatable({}, {__index =
		function(self, key)
			if RAID_CLASS_COLORS[key] then
				local c = RAID_CLASS_COLORS[key]
				self[key] = "|cff" .. string.format("%02x%02x%02x", c.r * 255, c.g * 255, c.b * 255)
				return self[key]
			else
				return "|cffa0a0a0"
			end
		end
	})

	-- Helper table to cache colored player names.
	local coloredName = setmetatable({}, {__index =
		function(self, key)
			if type(key) == "nil" then return nil end
			local class = select(2, UnitClass(key))
			if class then
				self[key] = hexColors[class] .. key .. "|r"
				return self[key]
			else
				return hexColors[key] .. key .. "|r"
			end
		end
	})
	
	--[[function addon:GUILD_ROSTER_UPDATE()
		if updating then return end
		updating = true
		--if self:IsEventRegistered("GUILD_ROSTER_UPDATE") then
			self:UnregisterEvent("GUILD_ROSTER_UPDATE")
		--end

		local offline = GetGuildRosterShowOffline()
		local selection = GetGuildRosterSelection()
		SetGuildRosterShowOffline(true)
		local numGuildMembers = GetNumGuildMembers()
		for i = 1, numGuildMembers do
			local name, _, _, _, _, _, _, _, _, _, class = GetGuildRosterInfo(i)
			if name then
				if rawget(coloredName, name) then
					coloredName[name] = nil
				end
				guildMemberList[name] = class
			end
		end
		SetGuildRosterShowOffline(offline)
		SetGuildRosterSelection(selection)

		updating = nil
		self:RegisterEvent("GUILD_ROSTER_UPDATE")
	end]]
	
	local window = nil
	local raidselect = nil
	local AceGUI = LibStub("AceGUI-3.0")
	AceGUI:RegisterLayout("LootCouncil_List",
	 function(content, children)
		local height = 0
	 	local width = content.width or content:GetWidth() or 0
		local numchildren = #children
		for i, child in ipairs(children) do
			local frame = child.frame
			frame:ClearAllPoints()
			frame:Show()
			if i == 1 then
				frame:SetPoint("LEFT",content,"LEFT",0,0)
				frame:SetWidth(100)
			elseif i == 2 then
				frame:SetPoint("LEFT",children[1].frame,"RIGHT",0,0)
				child:SetWidth( width - 100 - (numchildren-2)*22 )
				--child.label:SetWidth( width - 100 - (numchildren-2)*20 )
			elseif i == #children then
				frame:SetPoint("RIGHT",content,"RIGHT",0,0)
			else
				frame:SetPoint("RIGHT",children[i+1].frame,"LEFT",0,0)
				--child:SetDisabled(true)
			end
			
			--[[if child.width == "fill" then
				child:SetWidth(width)
				frame:SetPoint("RIGHT",content,"RIGHT")
				if child.OnWidthSet then
					child:OnWidthSet(content.width or content:GetWidth())
				end
				if child.DoLayout then
					child:DoLayout()
				end
			elseif child.width == "relative" then
				child:SetWidth(width * child.relWidth)
				if child.OnWidthSet then
					child:OnWidthSet(content.width or content:GetWidth())
				end
				if child.DoLayout then
					child:DoLayout()
				end
			end]]
			
			height = height + (frame.height or frame:GetHeight() or 0)
		end
		--safecall( content.obj.LayoutFinished, content.obj, nil, height )
	 end
	)
	local emptytable = {}
	function addon:CreateWindow()
		
		
		local window = AceGUI:Create("Window")
		--f:SetCallback("OnClose",function(widget, event) AceGUI:Release(widget) end )
		window:SetTitle(L["Loot Council"] .. " " .. windowString)
		--f:SetStatusText("Raid info status")
		window:SetLayout("Flow")
		window.frame:SetMinResize((300+select("#", addon.councillors)*22+100),300)
		
		local councillors = AceGUI:Create("Label")
		--councillors:SetFontObject("GameFontNormal")
		councillors:SetText(L["Councillors: %s"]:format(table.concat(addon:GetCouncillors(), ", ")))
		window:AddChild(councillors)
		window.councillors = councillors
		councillors:SetFullWidth(true)
		local function DrawLoot(container, group)
			if addon.loots[tonumber(group)].stage == 0 then
				local button = AceGUI:Create("Button")
				button:SetFullWidth(true)
				button:SetText("Open Item for Council")
				
				button:SetCallback("OnClick", function()
					addon:StartLoot(tonumber(group))
				end)
				
				container:AddChild(button)
				window.button1 = button
				window.button2 = nil
			end
			
			if addon.loots[tonumber(group)].stage == 1 then
				local button = AceGUI:Create("Button")
				button:SetRelativeWidth(0.5)
				button:SetText("Close Item")
				
				button:SetCallback("OnClick", function()
					addon:StartLoot(nil)
				end)
				container:AddChild(button)
				window.button1 = button
				local button = AceGUI:Create("Button")
				button:SetRelativeWidth(0.5)
				button:SetText("Finished Voting")
				if addon.loots[tonumber(group)].votedone[pname] then
					button:SetDisabled(true)
				else
					button:SetDisabled(false)
				end
				button:SetCallback("OnClick", function()
					addon:FinishVote(group)
				end)
				container:AddChild(button)
				window.button2 = button
			end
			
			if addon.loots[tonumber(group)].stage == 2 then
				local button = AceGUI:Create("Button")
				button:SetRelativeWidth(0.5)
				button:SetText("Tally Votes")
				
				button:SetCallback("OnClick", function()
					addon:TallyVotes(group)
				end)
				container:AddChild(button)
				window.button1 = button
				local button = AceGUI:Create("Button")
				button:SetRelativeWidth(0.5)
				if addon.loots[tonumber(group)].votedone[pname] then
					button:SetDisabled(true)
				else
					button:SetDisabled(false)
				end
				button:SetText("Finished Voting")
				button:SetCallback("OnClick", function()
					addon:FinishVote(group)
				end)
				container:AddChild(button)
				window.button2 = button
			end
			
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(tonumber(group))
			local item = AceGUI:Create("InteractiveLabel")
			item:SetFullWidth(true)
			item:SetFont(GameFontNormal:GetFont(), 20)
			local text = itemLink
			--Spew("looted", addon.loots[group].looted)
			if select("#", addon.loots[group].looted) >= 1 then
				local c, cc = select("#", addon.loots[group].looted), 0
				--print(c)
				
				for k in pairs(addon.loots[group].looted) do
					if cc == 0 then
						text = text .. L[", Looted by: "]
					end
					text = text .. coloredName[k]
					cc = cc + 1
					--print(cc)
					if c ~= cc then
						text = text .. ", "
					end
				end
			end
			if addon.open == group then
				item:SetText(text .. L[", Closing in %d seconds"]:format(db.autoclosetime - timercount))
			elseif addon.voting == group then
				item:SetText(text .. L[", Voting closing in %d seconds"]:format(db.autovoteclosetime - timercount))
			else
				item:SetText(text)
			end
			item:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
			item:SetImage(itemTexture)
			item:SetImageSize(30,30)
			item:SetUserData("item", group)
			
			item:SetCallback("OnEnter", function()
				GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
				GameTooltip:SetHyperlink(itemLink)
				GameTooltip:Show()
			end)
			item:SetCallback("OnLeave", function()
				GameTooltip:Hide()
			end)
			window.item = item
			container:AddChild(item)
			
			
			
			local headings = AceGUI:Create("SimpleGroup")
			headings:SetFullWidth(true)
			headings:SetHeight(20)
			headings:SetLayout("LootCouncil_List")
			
			local playername = AceGUI:Create("Label")
			playername:SetFont(GameFontNormal:GetFont(),13)
			playername:SetText(L["Player"])
			headings:AddChild(playername)
			
			local message = AceGUI:Create("Label")
			message:SetFont(GameFontNormal:GetFont(),13)
			message:SetText(L["Item Message"])
			headings:AddChild(message)
			
			for _,councillor in pairs(addon:GetCouncillors()) do
				local councilicon = AceGUI:Create("Icon")
				councilicon:SetWidth(22)
				--councilicon:SetDisabled(false)
				councilicon:SetImageSize(18,18)
				if addon.loots[tonumber(group)].votedone[councillor] then
					councilicon:SetImage("Interface\\RAIDFRAME\\ReadyCheck-Ready")
				else
					councilicon:SetImage("Interface\\RAIDFRAME\\ReadyCheck-NotReady")
				end
				--councilicon:SetDisabled(false)
				councilicon:SetCallback("OnEnter", function()
					GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
					GameTooltip:AddLine(councillor)
					GameTooltip:Show()
				end)
				councilicon:SetCallback("OnLeave", function()
					GameTooltip:Hide()
				end)
				
				councilicon:SetDisabled(false)
				councilicon.image:SetAlpha(1)
				window.votedone = window.votedone or {}
				window["votedone"][councillor] = councilicon
				headings:AddChild(councilicon)
			end
			
			container:AddChild(headings)
			
			local scroll = AceGUI:Create("ScrollFrame")
			scroll:SetFullHeight(true)
			scroll:SetFullWidth(true)
			scroll:SetLayout("List")
			container:AddChild(scroll)
			--local players = {}
			
			for player,messages in pairs(addon.loots[tonumber(group)].players or emptytable) do
				--local number = #players+1
				for messagenum,message in pairs(messages) do
					local pgroup = AceGUI:Create("SimpleGroup")
					pgroup:SetFullWidth(true)
					pgroup:SetHeight(20)
					pgroup:SetLayout("LootCouncil_List")
					
					local playername = AceGUI:Create("Label")
					--playername:SetWidth(100)
					playername:SetFont(GameFontNormal:GetFont(),13)
					--playername:SetRelativeWidth(0.2)
					playername:SetText(coloredName[player])
					pgroup:AddChild(playername)
					
					local pitem = AceGUI:Create("InteractiveLabel")
					local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(message.message)
					--pitem:SetRelativeWidth(0.8)
					--pitem:SetFullWidth(true)
					--pitem:SetFontObject(GameFontNormal)
					pitem:SetFont(GameFontNormal:GetFont(),13)
					pitem:SetText(message.message)
					pitem:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
					--pitem:SetImage(itemTexture)
					--pitem:SetImageSize(14,14)
					
					pitem:SetCallback("OnEnter", function()
						GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
						GameTooltip:SetHyperlink(itemLink)
						--GameTooltip_SetDefaultAnchor( ItemRefTooltip, UIParent )
						--ItemRefTooltip:SetHyperlink(item.link)
						GameTooltip:Show()
						--ItemRefTooltip:Show()
					end)
					pitem:SetCallback("OnLeave", function()
						GameTooltip:Hide()
						--ItemRefTooltip:Hide()
					end)
					pgroup:AddChild(pitem)
					
					for _,councillor in pairs(addon:GetCouncillors()) do
						if pname == councillor then
							local councilcheck = AceGUI:Create("CheckBox")
							councilcheck:SetWidth(22)
							councilcheck:SetType("checkbox")
							if not addon.loots[tonumber(group)].votedone[councillor] then
								councilcheck:SetDisabled(false)
							else
								councilcheck:SetDisabled(true)
							end
							councilcheck:SetValue(addon.loots[tonumber(group)].players[player][messagenum].votes[councillor] or false)
							councilcheck:SetCallback("OnValueChanged", function(widget, event, value)
								addon:Vote(player, messagenum, group, value)
							end)
							pgroup:AddChild(councilcheck)
						else
							local councilicon = AceGUI:Create("Icon")
							councilicon:SetWidth(22)
							councilicon:SetImageSize(18,18)
							if addon.loots[tonumber(group)].votedone[councillor] then
								councilicon:SetDisabled(false)
							else
								councilicon:SetDisabled(true)
							end
							if addon.loots[tonumber(group)].players[player][messagenum].votes[councillor] then
								councilicon:SetImage("Interface\\RAIDFRAME\\ReadyCheck-Ready")
							else
								councilicon:SetImage("Interface\\RAIDFRAME\\ReadyCheck-NotReady")
							end
							councilicon:SetCallback("OnEnter", function()
								GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
								GameTooltip:AddLine(councillor)
								GameTooltip:Show()
							end)
							councilicon:SetCallback("OnLeave", function()
								GameTooltip:Hide()
							end)
							
							pgroup:AddChild(councilicon)
						end
					end
					scroll:AddChild(pgroup)
				end
			end
			addon.currentscroll = scroll
		end
		-- Callback function for OnGroupSelected
		local function SelectGroup(container, event, group)
			container:ReleaseChildren()
			addon.currenttab = tonumber(group)
			DrawLoot(container, group)
		end
		
		

		local loottabs = AceGUI:Create("TabGroup")
		loottabs:SetLayout("Flow")
		-- Setup which tabs to show
		loottabs:SetTabs(addon:GetTabs())
		-- Register callback
		loottabs:SetCallback("OnGroupSelected", SelectGroup)
		-- Set initial Tab (this will fire the OnGroupSelected callback)
		loottabs:SelectTab(addon:GetTabs(true))
		loottabs:SetFullWidth(true)
		loottabs:SetFullHeight(true)
		window:AddChild(loottabs)
		window:Hide()
		_G['LootCouncilFrame'] = window
		tinsert(UISpecialFrames,"LootCouncilFrame")
		self.window = window
		self.window.tabs = loottabs
		--tinsert(UISpecialFrames,"LootCouncilWindow")
		--ASDF = window
		
	end
end